using Xunit;
using XunitExt;

namespace LegacyCode.Tests
{
    public class ShoppingCartTest
    {
        [Fact]
        public void Cross_my_fingers()
        {
            ShoppingCart cart = new FakeCart(200.0m);
            cart.CalculateDiscount();

            cart.DiscountAmount.ShouldEqual(20.0m);
        }


        private class FakeCart : ShoppingCart
        {
            private readonly decimal _subTotal;

            public FakeCart(decimal subTotal)
            {
                _subTotal = subTotal;
            }

            protected override decimal CalculateSubTotal()
            {
                return _subTotal;
            }
        }
        
    }
}