using ExternalDependency;
using Xunit;
using XunitExt;

namespace LegacyCode.Tests
{
    public class SubclassAndOverrideExample
    {
        [Fact]
        public void Cross_my_fingers()
        {
            StubCart cart = new StubCart(200.0m);
            cart.CalculateDiscount();

            cart.DiscountAmount.ShouldEqual(20.0m);
        }

        private class StubCart : ShoppingCart
        {
            private readonly decimal _subTotal;

            public StubCart(decimal subTotal) : base(new StubShippingCalculator(0))
            {
                _subTotal = subTotal;
            }

            protected override decimal CalculateSubTotal()
            {
                return _subTotal;
            }
        }

        private class StubShippingCalculator : ShippingCalculator
        {
            private readonly decimal _shippingCost;

            public StubShippingCalculator(decimal shippingCost)
            {
                _shippingCost = shippingCost;
            }

            public override decimal CalculateShippingCosts(Order order)
            {
                return _shippingCost;
            }
        }
        
    }
}